/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.openzen.zenscript.codemodel.expression;

import org.openzen.zencode.shared.CodePosition;
import org.openzen.zenscript.codemodel.scope.TypeScope;
import org.openzen.zenscript.codemodel.type.ITypeID;

/**
 *
 * @author Hoofdgebruiker
 */
public class InterfaceCastExpression extends Expression {
	public final Expression value;
	
	public InterfaceCastExpression(CodePosition position, Expression value, ITypeID toType) {
		super(position, toType, value.thrownType);
		
		this.value = value;
	}

	@Override
	public <T> T accept(ExpressionVisitor<T> visitor) {
		return visitor.visitInterfaceCast(this);
	}

	@Override
	public Expression transform(ExpressionTransformer transformer) {
		Expression tValue = value.transform(transformer);
		return value == tValue ? this : new InterfaceCastExpression(position, tValue, type);
	}

	@Override
	public Expression normalize(TypeScope scope) {
		return new InterfaceCastExpression(position, value.normalize(scope), type.getNormalized());
	}
}
